image: golang:1.15-alpine

variables:
  REPO_NAME: gitlab.com/sea-eevee/marketplace-be


before_script:
  - mkdir -p /app/$(dirname $REPO_NAME)
  - ln -svf $CI_PROJECT_DIR /app/$REPO_NAME
  - cd /app/$REPO_NAME

stages:
  - lint
  - test
  - deploy

lint:
  stage: lint
  script:
    - go fmt $(go list ./... | grep -v /vendor/)

test:
  stage: test
  script:
    - apk add build-base
    - go test -v -coverprofile .testCoverage.txt $(go list ./... | grep -v /vendor/)

deploy:
  stage: deploy
  image: alpine
  before_script:
    - apk add openssh-client
    - eval $(ssh-agent -s)
    - echo "$SSH_PRIVATE_KEY" | tr -d '\r' | ssh-add -
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
  script:
    - ssh -o StrictHostKeyChecking=no "$AWS_EC2_URL" "cd ~/marketplace/backend/admin; git pull; make app-reload"